/**
* @author Dirk Nordmann
* @date   14.01.2002
*/
package xml2rtf.xml;

import java.util.StringTokenizer;

public abstract class XmlTokenizer
{
    protected StringTokenizer _st;
    
    public abstract String getNextToken();
    
    protected String cleanString(String s)
    {
        StringBuffer stringbuffer = new StringBuffer();
        for(int i = 0; i < s.length(); i++)
        {
            char c = s.charAt(i);
            if(c == '{' || c == '}' || c == '\\')
            {
                stringbuffer.append('\\');
                stringbuffer.append(c);
            } 
            else if(c > '\177')
            {
                byte abyte0[] = (new Character(c)).toString().getBytes();
                for(int j = 0; j < abyte0.length; j++)
                {
                    int k = abyte0[j] & 0xff;
                    stringbuffer.append("\\'").append(Integer.toHexString(k));
                }
            } 
            else if (c == '\t')
                    stringbuffer.append(' ');
            else if (c >= ' ')
                    stringbuffer.append(c);
        }
        return stringbuffer.toString();
    }

}